typedef struct list {
    struct list *next;
} List;

typedef  struct  Symbol  {    /* symbol table entry */
    struct  Symbol  *next;  /* link to next */
    char    *name;
    int      value;
    int      line;
    int      type;
    struct  ref    *reflist;
    struct  ref    *xref;
} Symbol;

typedef struct  ref       {  /* forward references */
    struct   ref    *next;
    int      address;
    int      line;
} ref;

#define localref(s)  (strlen((s)->name) == 2 &&\
		      (s)->name[0] >= '0' && (s)->name[0] <= '9' &&\
		      ((s)->name[1] == 'B' || (s)->name[1] == 'F'))

Symbol *install(char *s, int v, int l),  *lookup(char *s);       
ref *addref(ref *p, int loc, int line);
void sort_symbols(void);
void sort_refs(Symbol *s);

int yylex(void);
int yyerror(char *s);
void init_lex(FILE *fp, int debug);

void tlist(char *fmt, ...);

